---
# SNMP Generator && SNMP Exporter
# Generator reads
# Setup SNMP Exporter on the server.

# I must gather facts here or prometheus_reconfigure fails.
- name: gather_facts
  hosts: prometheus
  tasks: [ ]
  tags: prometheus_configure

- name: generate_snmp_yml
  hosts: prometheus
  become: yes
  tasks:
    - ansible.builtin.copy:
        src: roles/snmp/files/mibs/
        dest: /usr/share/snmp/mibs
        owner: root
        group: root
        mode: 0644
  roles:
    - snmp-generator
  tags:
    - snmp-generator-install
    - snmp-generator-mibs

- name: snmp_exporter
  hosts: prometheus
  become: yes
  roles:
    - cloudalchemy.snmp-exporter
  tags:
    - snmp_exporter

- name: validate_services_running
  hosts: prometheus
  tasks:
  - name: get service facts
    service_facts:

  - name: Ensure the service is running.
    assert:
      that:
        - ansible_facts.services["{{ item }}.service"].status == "enabled"
        - ansible_facts.services["{{ item }}.service"].state == "running"
    with_items:
      - snmp_exporter
  tags:
    - facts
